﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@model CyberaniumModels.OrganoGrams
@{
    ViewData["Title"] = "Index";
    //Layout = "~/Views/Shared/_Layout.cshtml";
}
<style>
    tr td:first-child {
        text-align: left;
    }
    #tblProcess .btn-group.show{
        border:none;
    }
</style>
@if (!string.IsNullOrEmpty(TempData["success"]?.ToString()))
{
    <script>
        toastr.success('@TempData["success"]')
    </script>
}
else if (!string.IsNullOrEmpty(TempData["error"]?.ToString()))
{
    <script>
        toastr.error('@TempData["error"]')
    </script>
}
<link href="~/Script/summernote/summernote.css" rel="stylesheet" />
<script src="~/Script/Master/Layout.js"></script>

<script>
    $(document).ready(function () {
        $('.multiple').multiselect({
            enableFiltering: true,
            includeSelectAllOption: true
        });
        if ($('#Id').val() > 0) {
            showForm()
            GetFunctionsByOrgId($('#Id').val(), 0);
            //$.get('/ApplicationManagement/ThreatEnabler/GetControlCategoryByOrgId', { parentOrgId: $("#Id").val(), childOrgId: $("#ChildOrg").val() }, function (res) {
            //    $('#divDdlEnabler select').empty();
            //    if (res.length > 0) {
            //        $.each(res, function (i, item) {
            //            $('#divDdlEnabler select').append('<option value="' + item.value + '">' + item.name + '</option>');
            //        })
            //        $('#divDdlEnabler select').multiselect('rebuild');
            //    }
            //})
        }
    })
</script>
<script src="~/Script/Master/Layout.js"></script>
<section>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Processes Enabler Mapping</h1>
            <div class="titile_line"></div>
        </div>
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="service_line" id="dvForm">
                        <form asp-area="ApplicationManagement" asp-controller="ProcessEnabler" asp-action="Index" id="form" method="post"
                              data-ajax="true"
                              data-ajax-method="POST"
                              data-ajax-mode="replace"
                              data-loading-text="loading..."
                              data-ajax-update="#ajaxresult"
                              data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/ProcessEnabler/Index');"
                              data-ajax-failure="Errmsg(data);">
                            @Html.HiddenFor(m => m.Id)
                            @Html.HiddenFor(m => m.ChildOrgXML)
                            <div class="pb-2 mt-4 mb-2 border-bottom box_title">
                                Process Enabler Mapping
                            </div>
                            <div class="row">
                                <div class="col-12 text-center">
                                    <label>Select Organization Type</label>
                                    <div class="select_box m_bottom">
                                        <label class="radio-inline">
                                            <input type="radio" name="Organization" value="0" onclick="ManageOrganizationDiv(this)" checked>Parent Organization
                                        </label>
                                        <label class="radio-inline">
                                            <input type="radio" name="Organization" value="1" onclick="ManageOrganizationDiv(this)">Child Organization
                                        </label>
                                    </div>
                                </div>
                            </div>
                            <div class="mb-2 border-bottom box_title"></div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12" style="display:none;" id="divChildOrg">
                                    <label>Child Company</label>
                                    <div class="select_box m_bottom">
                                        @Html.DropDownListFor(m => m.ChildOrgId, Model.DdlChildOrg, "--Select--", new { @class = "form-control m_no", onchange = "GetFunctionsByOrgId($('#Id').val(),$(this).val());" })
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Function</label>
                                    <div class="select_box m_bottom">
                                        <select class="form-control m_no" asp-for="FunctionId" onchange="GetProcessTable(this)"><option value="0">Select Function</option></select>
                                    </div>
                                </div>
                            </div>
                            <div class="row" id="divTblProcess" style="display:none">
                                <div class="col-6">
                                    <table class="table table-striped" id="tblProcess">
                                        <thead class="bg-primary">
                                            <tr>
                                                <th>Process</th>
                                                <th>Enabler</th>
                                                <th>Action</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                            @*<div id="divDdlEnabler" hidden>
                                    <select class="form-control m_no multiple chosen-select" multiple="multiple"></select>
                                </div>*@
                            <script>
                                function showForm() {
                                    $('#dvDataTable').hide();
                                    $('#dvForm').removeAttr('class');
                                }
                                function hideForm() {
                                    $('#dvDataTable').show();
                                    $('#dvForm').attr('class', 'service_line');
                                }
                                function ManageOrganizationDiv(checkbox) {
                                    var val = parseInt($(checkbox).val());
                                    if (val > 0) {
                                        $('#divChildOrg').show();
                                        $('#FunctionId').html('<option value="0">Select Function</option>');
                                    } else {
                                        $('#divChildOrg').hide();
                                        GetFunctionsByOrgId($('#Id').val(), 0);
                                    }
                                    $.get('/ApplicationManagement/ThreatEnabler/GetControlCategoryByOrgId', { parentOrgId: $("#Id").val(), childOrgId: $("#ChildOrg").val() }, function (res) {
                                        $('#divDdlEnabler select').empty();
                                        if (res.length > 0) {
                                            $.each(res, function (i, item) {
                                                $('#divDdlEnabler select').append('<option value="' + item.value + '">' + item.name + '</option>');
                                            })
                                            $('#divDdlEnabler select').multiselect('rebuild');
                                        }
                                    })
                                }
                                function GetFunctionsByOrgId(parentOrgId, childOrgId) {
                                    $.get('/ApplicationManagement/ProcessEnabler/GetFunctionsByOrgId', { parentOrgId: parentOrgId, childOrgId: childOrgId }, function (data) {
                                        $('#FunctionId').empty();
                                        var html = '<option value="0">Select Function</option>';
                                        $.each(data, function (i, item) {
                                            html += '<option value="' + item.id + '">' + item.functionName + '</option>'
                                        })
                                        $('#FunctionId').html(html);
                                    });
                                }
                                function GetProcessTable(select) {
                                    var functionId = $(select).val();
                                    if (functionId > 0) {
                                        var html = '<select class="form-control m_no multiple chosen-select" multiple="multiple"><option value="multiselect-all">Select All</option>';
                                        $.ajax({
                                            url: '/ApplicationManagement/ThreatEnabler/GetControlCategoryByOrgId',
                                            async: false,
                                            data: { parentOrgId: $("#Id").val(), childOrgId: $("#ChildOrg").val() },
                                            success: function (res) {
                                                if (res.length > 0) {
                                                    $.each(res, function (i, item) {
                                                        html += '<option value="' + item.value + '">' + item.name + '</option>';
                                                    })
                                                }
                                            }
                                        })
                                        html += '</select>';
                                        $.get('/ApplicationManagement/FunctionDashboard/GetProcesses', { functionId: functionId }, function (res) {
                                            var tbody = '';
                                            $.each(res, function (i, item) {
                                                tbody += '<tr>' +
                                                    '<td id="' + item.id + '">' + item.processIdentified + '</td>' +
                                                    '<td>' + html + '</td>' +
                                                    '<td><input type="button" class="btn btn-info" value="Add" onclick="OpenModal(this)" /></td>' +
                                                    '</tr>';
                                            })
                                            $('#tblProcess tbody').html(tbody);
                                            $('.multiple').multiselect();
                                            $('#divTblProcess').show();
                                        })
                                    } else {
                                        $('#divTblProcess').hide();
                                        toastr.warning('Please select a function!');
                                    }
                                }
                                function OpenModal(btn) {
                                    var procName = $(btn).closest('tr').find('td:eq(0)').text();
                                    var procId = $(btn).closest('tr').find('td:eq(0)').attr('id');
                                    $('#tblEnablers').attr('value', procId);
                                    $('#exampleModalScrollableTitle').text('Enabler mapping for ' + procName);
                                    var thead = '<tr>', tbody = '<tr>';
                                    $(btn).parent('td').parent('tr').find('td:eq(1) select option:selected').each(function (i, option) {
                                        var conCatId = $(option).val();
                                        var table = '<table class="table table-striped m-0 p-0" id="table_' + conCatId + '"><tbody>';
                                        if (conCatId == 'multiselect-all') return;
                                        thead += '<th><input type="checkbox" checked onclick="manageCheckbox(this)" value="' + conCatId + '"/>&nbsp;' + $(option).text() + '</th>';
                                        tbody += '<td id="td_' + conCatId + '"></td>';
                                    })
                                    thead += '</tr>', tbody += '</tr>';
                                    $('#tblEnablers thead').html(thead);
                                    $('#tblEnablers tbody').html(tbody);
                                    var ChildOrgId = $("#ChildOrgId").val();
                                    var OrganizationId = $("#Id").val();
                                    if (ChildOrgId == "" || ChildOrgId == null) {
                                        ChildOrgId = 0;
                                    }
                                    $(btn).parent('td').parent('tr').find('td:eq(1) select option').each(function (i, option) {
                                        var conCatId = $(option).val();
                                        var table = '<table class="table table-striped m-0 p-0" id="table_' + conCatId + '"><tbody>';
                                        if (conCatId == 'multiselect-all') return;
                                        $.get('/ApplicationManagement/ThreatEnabler/GetFirstQuesAnswersByConCatId', { controlCategoryId: conCatId, ChildOrgId: ChildOrgId, OrganizationId: OrganizationId }, function (res) {
                                            debugger;
                                            $.each(res, function (i, val) {
                                                table += '<tr><td><input type="checkbox" checked value="' + val.value + '"/>&nbsp;' + val.answer + '</td></tr>';
                                            })
                                            table += '</tbody></table>';
                                            setTimeout(function () {
                                                $('#td_' + conCatId).html(table);
                                            }, 300);
                                        })
                                    })
                                    $('#exampleModalCenter').modal('show');
                                }
                                function prepareXMLForSave() {
                                    var processEnablerXML = [], sn = 0;
                                    var processId = parseInt($('#tblEnablers').attr('value'));
                                    $('#tblEnablers tbody').find('table').each(function (i, table) {
                                        var conCatId = parseInt($(table).attr('id').split('_')[1]);
                                        $(table).find('input[type="checkbox"]:checked').each(function (iCheck, checkbox) {
                                            var answerId = parseInt($(checkbox).val());
                                            processEnablerXML[sn] = {
                                                ConCatId: conCatId,
                                                AnswerId: answerId
                                            }
                                            sn++;
                                        })
                                    })
                                    var model = {
                                        ParentOrgId: $('#Id').val(),
                                        ChildOrgId: $('#ChildOrgId').val(),
                                        FunctionId: $('#FunctionId').val(),
                                        ProcessId: processId,
                                        ProcessEnablerXML: JSON.stringify(processEnablerXML)
                                    }
                                    $.post('/ApplicationManagement/ProcessEnabler/SubmitProcessEnabler', { model: model }, function (res) {
                                        $('#exampleModalCenter').modal('hide');
                                        //$('a[href="/ApplicationManagement/ProcessEnabler/Index"]').click();
                                        res.isSuccess ? toastr.success('Saved successfully.') : toastr.error('Something went wrong!');
                                    })
                                }
                                function manageCheckbox(checkbox) {
                                    var isChecked = $(checkbox).is(':Checked');
                                    var id = $(checkbox).val();
                                    if (isChecked) {
                                        $('#table_' + id).find('input').prop('checked', true);
                                    } else {
                                        $('#table_' + id).find('input').prop('checked', false);
                                    }
                                }
                            </script>
                            <table class="table" id="tblProcessEnabler" style="border: 1px solid #eee">
                                <tbody>
                                    @if (Model.ProcessEnablerList != null)
                                    {
                                        @if (Model.ProcessEnablerList.Count > 0)
                                        {
                                            var i = 0;
                                            foreach (var item in Model.ProcessEnablerList)
                                            {
                                                i = i + 1;
                                                <tr>
                                                    <td>
                                                        <label>Function</label>
                                                        <select id="FunctionId_@i" class="form-control m_no clsFunction" onchange="GetProcess(this,@i);"></select>
                                                        <script>
                                                            var xhtml = $('.clsFunction').html();
                                                            alert(xhtml);
                                                            $("#FunctionId_@i").html(xhtml);
                                                            $("#FunctionId_@i").val(@item.FunctionId);
                                                        </script>
                                                    </td>
                                                    <td>
                                                        <label>Process</label>
                                                    </td>
                                                    <td>
                                                        <label>Category</label>
                                                    </td>
                                                    <td>
                                                        <label>Enabler</label><br />
                                                    </td>
                                                    <td>
                                                        <button class="btn btn-info" style="margin-top:26px" type="button" id="addBtn"><i class="fa fa-plus"></i></button>
                                                    </td>
                                                </tr>
                                            }
                                        }
                                        else
                                        {
                                            <tr>
                                                <td>
                                                    <label>Function</label>
                                                    @Html.DropDownListFor(m => m.FunctionId, Enumerable.Empty<SelectListItem>(), "--Select--", new { @class = "form-control m_no clsFunction", @onchange = "GetProcess(this, 0)" })
                                                </td>
                                                <td>
                                                    <label>Process</label>
                                                    <select class="form-control" asp-for="ProcessId">
                                                        <option value="">--select--</option>
                                                    </select>
                                                </td>
                                                <td>
                                                    <label>Category</label>
                                                    @Html.DropDownListFor(m => m.ControlCategoyID, Enumerable.Empty<SelectListItem>(), "--Select--", new { @class = "form-control clsControlCategory", required = "required", @onchange = "fn_GetEnabler(this);" })
                                                </td>
                                                <td>
                                                    <label>Enabler</label><br />
                                                    <select class="form-control multiple chosen-select" multiple="" asp-for="EnablerId">
                                                    </select>
                                                </td>
                                                <td>
                                                    <button class="btn btn-info" style="margin-top:26px" type="button" id="addBtn"><i class="fa fa-plus"></i></button>
                                                </td>
                                            </tr>

                                        }

                                    }
                                </tbody>
                            </table>
                            <br />
                            <div class="row">
                                <div class="col-md-12 col-sm-12 col-xs-12">
                                    <div class="back_btn">
                                        <div class="back_btn_in">
                                            <input type="button" id="btnBack" name="Submit" value="Back" onclick="hideForm()">
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="assign_panel assign_section" id="dvDataTable">
                        <div class="assign_box active_block fade in">
                            <div class="row">
                                <div class="table_control">
                                    <table id="example2" class="table table-bordered table-hover">
                                        <thead>
                                            <tr>
                                                <th style="width:70px">SN</th>
                                                <th>Parent Organization Name</th>
                                                <th>Corporate Office Location</th>
                                                <th style="width:130px">Action</th>
                                            </tr>
                                        </thead>
                                        @{int sn = 0;}
                                        @foreach (var item in Model.OrganizationsList)
                                        {
                                            <tr>
                                                <td>@(++sn)</td>
                                                <td>@item.ParentOrgName</td>
                                                <td>@item.CorporateOfficeLocation</td>
                                                <td>
                                                    <a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Index" asp-route-parentOrgId="@item.Id" asp-controller="ProcessEnabler" asp-area="ApplicationManagement" class="edit_btn"></a>
                                                    @*<a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="BlockDeleteOrganization" asp-route-Id="@item.Id" asp-route-Type="0" asp-controller="Organization" asp-area="ApplicationManagement" class="Active_btn" asp-route-ActionName="@(item.IsActive ? "InActive" : "Active")"></a>*@
                                                    @*<a class="delete_btn" onclick="Confirmation('@item.Id')"></a>*@
                                                </td>
                                            </tr>
                                        }
                                        <tbody>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<div class="modal fade" id="exampleModalCenter" tabindex="-1" role="dialog" aria-labelledby="exampleModalScrollableTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-scrollable modal-dialog-centered modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h3 class="modal-title" id="exampleModalScrollableTitle">Enabler Mapping</h3>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <table class="table table-striped" id="tblEnablers">
                    <thead class="bg-primary">
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                <input type="button" class="btn btn-primary" onclick="prepareXMLForSave()" value="Submit" />
            </div>
        </div>
    </div>
</div>
@*<script type="text/javascript">
        var Id = 0;
        //function Fn_Edit(id) {
        //    $("input[name=Id]").val(id);
        //    Id = id;
        //    BindDDL(id);
        //}
        //function BindDDL(id) {
        //    $.ajax({
        //        url: "/ApplicationManagement/ProcessEnabler/Get",
        //        type: "POST",
        //        cache: false,
        //        data: { ChildId: id },
        //        success: function (result) {
        //            $("select[name=CategoryId]").find('option:not(:first)').remove();
        //            //$("select[name=FunctionId]").find('option:not(:first)').remove();
        //            //$("select[name=EnablerId]").find('option:not(:first)').remove();
        //            for (var i = 0; i < result.values.length; i++) {
        //                $("select[name=CategoryId]").append("<option value=" + result.values[i].id + ">" + result.values[i].name + "</option>");
        //            }
        //            //for (var i = 0; i < result.function.length; i++) {
        //            //    $("select[name=FunctionId]").append("<option value=" + result.function[i].id + ">" + result.function[i].functionName + "</option>")
        //            //}
        //            //for (var i = 0; i < result.enabler.length; i++) {
        //            //    $("select[name=EnablerId]").append("<option value=" + result.enabler[i].id + ">" + result.enabler[i].name + "</option>")
        //            //}
        //            $(".multiple").multiselect("rebuild");
        //            showForm();
        //        }
        //    });
        //}
        function fn_GetChildorgControlCategory(input) {
            $.ajax({
                url: "/ApplicationManagement/ProcessEnabler/GetChildOrgControlCategory",
                type: "POST",
                cache: false,
                data: { ChilOrgID: $(input).val() },
                success: function (result) {
                    $("select[name=ControlCategoyID]").find('option:not(:first)').remove();
                    $(".clsFunction").find('option:not(:first)').remove();
                    for (var i = 0; i < result.values.length; i++) {
                        $("select[name=ControlCategoyID]").append("<option value=" + result.values[i].value + ">" + result.values[i].name + "</option>");
                    }
                    for (var i = 0; i < result.functions.length; i++) {
                        $(".clsFunction").append("<option value=" + result.functions[i].id + ">" + result.functions[i].functionName + "</option>");
                    }
                },
                error: function (ex) {
                    console.log(ex.responseText);
                }
            });
        }
        function fn_GetEnabler(input) {
            var OrgId = $("#Id").val();
            var ChildOrgId = $("#ChildId").val();
            var CategoryId = $(input).val();
            $.ajax({
                url: "/ApplicationManagement/ProcessEnabler/GetEnabler",
                type: "POST",
                cache: false,
                data: { OrgId: OrgId, ChildOrgId: ChildOrgId, CategoryId: CategoryId },
                success: function (result) {
                    $("select[name=EnablerId]").find('option:not(:first)').remove();
                    for (var i = 0; i < result.values.length; i++) {
                        $("select[name=EnablerId]").append("<option value=" + result.values[i].id + ">" + result.values[i].name + "</option>");
                    }
                    $(".multiple").multiselect("rebuild");
                },
                error: function (ex) {
                    console.log(ex.responseText);
                }
            });

        }
        //function GetProcessById(value) {
        //    GetProcess(value);
        //}
        $("select[name=FunctionId]").change(function (e) {
            GetProcess(e.target.value);
        });
        //function GetProcess(id) {
        //    $.ajax({
        //        url: "/ApplicationManagement/ProcessEnabler/GetProcess",
        //        type: "POST",
        //        cache: false,
        //        data: { OrgId: id },
        //        success: function (list) {
        //            $("select[name=ProcessId]").find('option:not(:first)').remove();
        //            for (var i = 0; i < list.length; i++) {
        //                $("select[name=ProcessId]").append("<option value=" + list[i].id + ">" + list[i].processIdentified + "</option>");
        //            }
        //        },
        //        error: function (ex) {
        //            console.log(ex.responseText);
        //        }
        //    });
        //}

        //$("input[type=submit]").click(function () {
        //    if ($("select[name=OrganizationId]").val() == "" && $("select[name=OrganizationId]").val() == 0) {
        //        toastr.error("select organization name");
        //        return false;
        //    } else if ($("select[name=CategoryId]").val() == null) {
        //        toastr.error("select a category name");
        //        return false;
        //    } else if ($("select[name=ChildOrgId]").val() == 0) {
        //        toastr.error("select child organization name");
        //        return false;
        //    }
        //});

        //function getvalue(input) {
        //    var $tblrows = $("#DomainCritical tbody tr");
        //    $tblrows.each(function (index) {
        //        var $tblrow = $(this);


        //    });
        //}


        function fnSetMultiselectValue() {
            var arr = new Array();
            $('#tblProcessEnabler tbody tr').each(function (i, tr) {
                arr[i] = {
                    FunctionId: $(tr).find("td:nth-child(1) option:selected").val() != undefined ? $(tr).find("td:nth-child(1) option:selected").val() : 0,
                    ProcessId: $(tr).find("td:nth-child(2) option:selected").val() != undefined ? $(tr).find("td:nth-child(2) option:selected").val() : 0,
                    CategoryId: $(tr).find("td:nth-child(3) option:selected").val() != undefined ? $(tr).find("td:nth-child(3) option:selected").val() : 0,
                    EnablerId: $(tr).find("td:nth-child(4) option:selected").val() != undefined ? $(tr).find("td:nth-child(4) option:selected").val() : 0
                }
            });
            $('#ChildOrgXML').val(JSON.stringify(arr));
        }

        //function fn_GetQuestionnaire(select) {
        //    $("#que").removeClass("hidden");
        //    $("#dvmultiTable").empty();
        //    $('#CategoryId option:selected').each(function (i) {
        //        var CategoryId = $(this).val();
        //        var CategoryText = $(this).text();
        //        if (CategoryId == 'multiselect-all') {
        //            $("#dvmultiTable").empty();
        //            return;
        //        }
        //        var html = '<table class="table" id="tbl_' + CategoryId + '"><thead><tr>';
        //        $.get('/ApplicationManagement/Compliance/GetQuestionnaireById', { CategoryId: CategoryId }, function (data) {
        //            html += '<th colspan="' + parseInt(data.length + 2) + '">' + CategoryText + '</th></tr>';
        //            html += '<tr><th name="0">SN</th>';
        //            $.each(data, function (i, value) {
        //                html += '<th name=' + value.id + '>' + value.query + '</th>';
        //            });
        //            html += '<th name="0">Action</th></tr></thead><tbody><tr><td>1</td>';
        //            $.each(data, function (i, value) {
        //                html += '<td><input type="text" class="form-control ques' + value.id + '" /></td>';
        //            });
        //            html += '<td><input type="button" class="btn btn-info" value="Add" onclick="AddMoreAnswers(this)"/></td></tr></tbody></table>';
        //            $("#dvmultiTable").append(html);
        //        });
        //    });
        //    if ($("select[name=CategoryId]").val() == null) {
        //        $("#que").addClass("hidden");
        //    }
        //}

        //function AddMoreAnswers(input) {
        //    var tdLength = $(input).closest('tr').find('td').length;
        //    var sn = parseInt($(input).closest('tbody').find('tr:last td:eq(0)').text()) + 1;
        //    var html = '<tr><td>' + sn + '</td>';
        //    for (var i = 0; i < tdLength; i++) {
        //        if (i == 0 || i == tdLength - 1) { continue; }
        //        html += '<td>';
        //        html += $(input).closest('tbody').find('tr:first td').eq(i).html();
        //        html += '</td>';
        //    }
        //    html += '<td><input type="button" class="btn btn-danger" value="Remove" onclick="RemoveMoreAnswers(this)"></td></tr>';
        //    $(input).closest('tbody').append(html);
        //}

        function RemoveMoreAnswers(input) {
            $(input).closest('tr').remove();
        }
        function fnUpdate(Id, CountryId, ControlCategory, Query) {
            showForm()
            $('#Id').val(Id);
            $('#CountryId').val(CountryId);
            $('#ControlCategory').val(ControlCategory);
            $('#Query').val(Query);
            $('#EventType').val(1);
        }
        function fnBlockDelete(Id, Action, Type) {
            if (confirm('Are you sure you want to ' + Action + ' this Assesment?')) {
                $.get('/ApplicationManagement/Assesment/BlockDeleteAssesment', { Id: Id, EventType: Type }, function (data) {
                    if (data.code == 200) {
                        toastr.success(Action + ' successfully');
                        $('a[href="/ApplicationManagement/Assesment/Index"]').click();
                    } else {
                        toastr.error('Something went wrong!');
                    }
                });
            }
        }


        function fn_Activeincative(id, status) {
            Swal.fire({
                title: 'Are you sure?',
                text: 'You want to ' + status + ' this assesment',
                showCancelButton: true,
                confirmButtonText: status,
            }).then((result) => {
                /* Read more about isConfirmed, isDenied below */
                if (result.isConfirmed) {
                    $('#preloader').show();
                    $.ajax({
                        url: "/ApplicationManagement/Assesment/BlockDeleteAssesment",
                        type: "POST",
                        cache: false,
                        data: { Id: id, EventType: Type = 0 },
                        success: function (result) {
                            $('#preloader').hide();
                            toastr.success(status + " " + "successfully!!");
                            $('a[href="/ApplicationManagement/Assesment/Index"]').click();
                        }, error: function (ex) {
                            console.log(ex.statusText);
                        }
                    })
                }
            });
        }
        //$("select[name=ChildId]").change(function (e) {
        //    $.ajax({
        //        url: "/ApplicationManagement/ProcessEnabler/Index",
        //        type: "GET",
        //        cache: false,
        //        data: { ChildId: e.target.value },
        //        success: function (list) {
        //        },
        //        error: function (ex) {
        //            console.log(ex.responseText);
        //        }
        //    });
        //});

        $("#addBtn").click(function () {
            var rowCount = $('#tblProcessEnabler tbody tr').length;
            $("#tblProcessEnabler tbody").append('<tr><td><label>Function</label><select class="form-control" data-val="true" onchange="GetProcess(this,' + rowCount + ');" id="FunctionId"  name="FunctionId">' + $('.clsFunction').html() + '</select></td><td><label>Process</label><select class="form-control" data-val="true" id="ProcessId_' + rowCount + '" name="ProcessId"><option value="">--select--</option></select></td><td><label>Category</label><select class="form-control" data-val="true" id="ControlCategoyID" name="ControlCategoyID">' + $('.clsControlCategory').html() + '</select></td><td><label>Enabler</label><br/><select class= "form-control multiple chosen-select" multiple="" data-val="true" id="EnablerId" name="EnablerId"></select></td><td><input type="button" name="remove" value="-" style="margin-left:-14px;margin-top:26px" class="btn btn-danger" onclick="removeText($(this))" /></td></tr>');
            $(".multiple").multiselect('rebuild');
        });

        //function divAppend() {
        //    $("#multiRow").append('<div class="row"><div class="col-md-2"><label>Function</label><select class="form-control" data-val="true" onchange="GetProcessById(this.value)" id="FunctionId" name="FunctionId"><option value="">--select--</option></select></div><div class="col-md-2"><label>Process</label><select class="form-control" data-val="true" id="ProcessId" name="ProcessId"><option value="">--select--</option></select></div><div class="col-md-2"><label>Category</label><select class="form-control" data-val="true" id="CategoryId" onchange="bindCatagery(this.value)" name="CategoryId"><option value="">--select--</option></select></div><div class="col-md-2"><label>Enabler</label><select class= "form-control multiple chosen-select" multiple data-val="true" id="EnablerId" name="EnablerId"></select></div><div class="col-md-2"><input type="button" name="remove" value="Remove" class="btn btn-danger" onclick="removeText()" /></div></div>');
        //    $(".multiple").multiselect('rebuild');
        //    BindDDL(Id);
        //}

        //function bindCatagery(value) {
        //    GetCategoryDetailsById(value);
        //}

        //$("select[name=CategoryId]").change(function (e) {
        //    GetCategoryDetailsById(e.target.value);
        //});

        //function GetCategoryDetailsById(id) {
        //    $("#enabler").hide();
        //    $.ajax({
        //        url: "/ApplicationManagement/ProcessEnabler/GetCategoryDetails",
        //        type: "POST",
        //        cache: false,
        //        data: { id: id },
        //        success: function (list) {
        //            //$("#multiRow div:nth-child(5)").remove();
        //            removeText();
        //            if (list.length > 0) {
        //                var textbox = "";
        //                for (var i = 0; i < list.length; i++) {
        //                    textbox = '<label name="Query" class="label-control">' + list[i].query + '</label>';
        //                }
        //                $("#multiRow").append('<div class="col-md-2"><label>' + $("select[name=CategoryId] option:selected").text() + '</label>' + textbox + '<button class="btn btn-info" type="button" onclick="divAppend()" id="addBtn"><i class="fa fa-plus"></i>Add</button></div>');
        //            } else {
        //                $("#enabler").show();
        //                $("#multiRow").append('<button class="btn btn-info" type="button" onclick="divAppend()" id="addBtn"><i class="fa fa-plus"></i>Add</button>');
        //            }
        //        },
        //        error: function (ex) {
        //            console.log(ex.responseText);
        //        }
        //    });
        //}
        function GetProcess(input, index) {
            var CurrentTr = $(input).closest('tr');
            var CurrentTrID = $(CurrentTr).find('td:nth-child(2) select').attr('id');
            var pp = "#" + CurrentTrID;
            var pop = '#tblProcessEnabler tbody tr ' + pp;
            $(pop).empty();
            $(pop).append('<option value="">--Select--</option>')
            $.ajax({
                url: "/ApplicationManagement/ProcessEnabler/GetProcess",
                type: "POST",
                cache: false,
                data: { OrgId: $(input).val() },
                success: function (list) {
                    for (var i = 0; i < list.length; i++) {
                        $(pop).append($('<option>', {
                            value: list[i].id, text: list[i].processIdentified
                        }));
                    }
                },
                error: function (ex) {
                    console.log(ex.responseText);
                }
            });

        }
        function removeText(elem) {
            var par = elem.parent().parent();
            par.remove();
        }
    </script>*@
<script>
    function Confirmation(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to delete this assesment',
            showCancelButton: true,
            confirmButtonText: 'Delete',
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/ApplicationManagement/Assesment/BlockDeleteAssesment",
                    type: "POST",
                    cache: false,
                    data: { Id: id, EventType: Type = 1 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success("Delete successfully!!");
                        $('a[href="/ApplicationManagement/Assesment/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
</script>